use std::collections::HashSet;

fn main() {
    // heterogeneous tuples are possible
    let tuple: (u8, u16) = (1, 4u16);
    println!("debug representation = {:?}", tuple);
    println!("first value = {:?}", tuple.0);

    // homogeneous vectors can hold a growable collection of data
    let mut dates = Vec::new();
    dates.push("2023-04-14");
    dates.push("2023-04-15");
    println!("count = {}", dates.len());

    // shorthand declaration for vectors (no modification, not "mut" required)
    let datas = vec!["2023-04-14", "2023-04-15"];
    println!("first element: {}", datas.first().unwrap());

    let mut visited = HashSet::with_capacity(42);
    /*visited.insert(2);
    visited.insert(3);
    visited.insert(5);
    visited.insert(7);
    visited.insert(5);*/
    println!("{:?}", visited);
}
