struct Workshop {
    date: String,
    lead: String,
    attendees: u32,
    has_started: bool,
}

impl Workshop {
    fn with_default_parameters() -> Workshop {
        Workshop {
            date: "2023-04-13".to_string(),
            lead: "Lukas".to_string(),
            attendees: u32::MAX,
            has_started: true,
        }
    }

    fn room_is_full(&self) -> bool {
        self.attendees == u32::MAX
    }
}

type BoothIdentifier = u32;

enum Submission {
    LightningTalk,
    Booth(BoothIdentifier),
    Workshop(Workshop),
    Lecture{ title: String, speaker: String },
}

fn main() {
    let glt23_rust = Workshop::with_default_parameters();
    println!("Is the room full? {}", glt23_rust.room_is_full());

    let submission = Submission::LightningTalk;
    println!("What do you plan to submit? {:?}", submission);
}
