#[derive(Debug)]
struct Workshop {
    date: String,
    lead: String,
    attendees: u32,
    has_started: bool,
}

type BoothIdentifier = u32;

#[derive(Debug)]
enum Submission {
    LightningTalk,
    Booth(BoothIdentifier),
    Workshop(Workshop),
    Lecture{ title: String, speaker: String },
}

fn main() {
    let glt23_rust = Workshop {
        date: "2023-04-13".to_string(),
        lead: "Lukas".to_string(),
        attendees: u32::MAX,
        has_started: true,
    };
    let submission = Submission::Workshop(glt23_rust);

    println!("What do you plan to submit? {}",
        match submission {
            Submission::LightningTalk => "lightning talk".to_string(),
            Submission::Booth(id) => format!("booth #{}", id),
            Submission::Workshop(w) => format!("workshop happening on {:?}", w),
            Submission::Lecture{ title, speaker } => format!("lecture by {speaker} on '{title}'"),
        }
    );

    let submission2 = Submission::LightningTalk;
    if let Submission::LightningTalk = submission2 {
        println!("Oh, I like lightning talks!");
    }
}