fn incrementing_sum(max: i32) -> i32 {
    (1..=max).reduce(|a, b| {
        a + b
    }).unwrap()
}

enum ReturnValue {
    Success(i32),
    Failure(String)
}

fn compute_incrementing_sum(max: i32) -> ReturnValue {
    match max {
        0 => ReturnValue::Failure("0 is not a valid argument".to_string()),
        arg if arg < 0 => ReturnValue::Failure("argument must be positive".to_string()),
        _ => ReturnValue::Success(incrementing_sum(max)),
    }
}


fn main() {
    let sum100 = incrementing_sum(100);
    println!("1 + 2 + 3 + … + 100 = {}", sum100);

    let arg = 42;
    match compute_incrementing_sum(arg) {
        ReturnValue::Failure(err) => eprintln!("error: {err}"),
        ReturnValue::Success(sum) => println!("1 + 2 + 3 + … + {arg} = {sum}"),
    }
}
