use std::num::ParseIntError;

trait IncrementableString {
    fn increment_if_u32_string(&self) -> Result<String, ParseIntError>;
}

impl IncrementableString for &str {
    fn increment_if_u32_string(&self) -> Result<String, ParseIntError> {
        let integer: u32 = match self.parse() {
            Err(err) => return Err(err),
            Ok(num) => num,
        };

        let new_integer = integer + 1;
        Ok(format!("{}", new_integer))
    }
}

fn main() {
    let number_string = "42";
    let non_number = "abc";
    println!("{:?}", number_string.increment_if_u32_string());
    println!("{:?}", non_number.increment_if_u32_string());
}
