use std::fmt::Display;
use std::time::SystemTime;

trait LogPrint {
    fn print(&self) -> String;
}

impl LogPrint for u32 {
    fn print(&self) -> String {
        match SystemTime::now().duration_since(SystemTime::UNIX_EPOCH) {
            Ok(n) => format!("[UNIX epoch + {}] {}", n.as_secs(), &self),
            Err(err) => panic!("Sorry, SystemTime failed {}", err),
        }
    }
}

fn main() {
    println!("{}", (3).print());
    println!("{}", (45.2).print());
    println!("{}", "tiraen".print());
}
