fn into_example() {
    let source: u16 = 42;
    let target: u32 = source.into();

    println!("target is {:0b}", target);
}

trait ConvertInto {
    type TargetType;
    fn convert(&self) -> Self::TargetType;
}

struct MyType {
    value: u8,
}

impl ConvertInto for MyType {
    type TargetType = u32;

    fn convert(&self) -> Self::TargetType {
        self.value as Self::TargetType
    }
}

fn convert_example() {
    let source: MyType = MyType { value: 42 };
    let target: u32 = source.convert();

    println!("target is {:0b}", target);
}


fn main() {
    // An example using the Into trait
    into_example();

    // An example using our own convert implementation
    convert_example();
}
